//------------------------------------------------------------------------------

//Dies ist das eigentliche Patchprgramm. Der Patch Generator extrahiert diese
//Exedatei und hngt die Infos an die Datei ran. Der Patch liest sie dann aus.
//Hinweis: Die kompilierte Datei hab ich noch mit Aspack gepackt.
// -> readme.txt

//This is the real patch. The patch generator writes this file to disk and adds
//the patch info to the end of the patchfile. The Patchfile reads info from
//the end of its own file. -> readme.txt
//Notice: I have packed the file with Aspack.

//------------------------------------------------------------------------------

program Patcher;

uses
  Windows,Messages,Classes,sysutils;


{$R patcherdialog.res}



var
  anzahl_patches : Integer;
  offsets : array of Integer;
  oribytes, patchbytes : array of Integer;
  filesize : longint;
  target_file : string;
  target_name : string;
  authorname : string;

// liest eine String aus einer Datei
// function to read a string from a file  
function Read_Str(file1 : TMemoryStream; lang : Integer) : string;
var
  i : Integer;
  temp : Integer;
  ch : char;
  s : string;
begin
  s := '';
  for i := 1 to lang do
  begin
    file1.Read(temp,1);
    ch := chr(temp);
    s := s + ch;
  end;
  result := s;

end;


procedure ReadPatchData(hdlg : HWND);
var
  Appmem : TMemoryStream;
  temp : Integer;
  i : Integer;    // loop variable
begin
  Appmem := TMemoryStream.Create;
  Appmem.Loadfromfile(paramstr(0));
  // how many patches (it's the last byte of a patch
  Appmem.Seek(appmem.size-1,sofrombeginning);
  Appmem.Readbuffer(anzahl_patches,1);

  // Set arrays
   Setlength(offsets,anzahl_patches+1);
   Setlength(oribytes,anzahl_patches+1);
   Setlength(patchbytes,anzahl_patches+1);

  // Offsets, Original Bytes and PatchBytes
  Appmem.Seek(-1,sofromCurrent);
  for i:= 1 to anzahl_patches do
  begin
     Appmem.Seek(-3,sofromCurrent);
     Appmem.Read(offsets[i],3);
     Appmem.Seek(-4,sofromCurrent);
     Appmem.Read(oribytes[i],1);
     Appmem.Seek(-2,sofromCurrent);
     Appmem.Read(patchbytes[i],1);
     Appmem.seek(-1,sofromCurrent);
  end;

  // Read Target Name
  Appmem.seek(-1,sofromCurrent);
  Appmem.ReadBuffer(temp,1);
  Appmem.Seek(-(temp+1),sofromcurrent);
  target_name := Read_str(appmem,temp);
  SetdlgItemtext(hdlg,10,pchar(target_name));
  Appmem.Seek(-temp,sofromcurrent);
  
  //Read Author Name
  Appmem.seek(-1,sofromCurrent);
  Appmem.ReadBuffer(temp,1);
  Appmem.Seek(-(temp+1),sofromcurrent);
  authorname := Read_str(appmem,temp);
  SetdlgItemtext(hdlg,13,pchar(authorname));
  Appmem.Seek(-temp,sofromcurrent);

  // Read Filesize
  Appmem.seek(-4,sofromCurrent);
  Appmem.ReadBuffer(filesize,4);
  SetdlgItemtext(hdlg,12,pchar(inttostr(filesize) + ' Bytes'));
  Appmem.seek(-4,sofromCurrent);

  //Read target_File
  Appmem.seek(-1,sofromCurrent);
  Appmem.ReadBuffer(temp,1);
  Appmem.Seek(-(temp+1),sofromcurrent);
  target_file := Read_str(appmem,temp);
  SetdlgItemtext(hdlg,11,pchar(target_file));
  Appmem.Seek(-temp,sofromcurrent);

  Appmem.free;

end;

procedure PatchTarget(hdlg : HWND);
var
  f : file;
  i : Integer;

begin
  AssignFile(f,target_file);
  {$I-}
  reset(F,1);
  {$I+}
  if IOResult <> 0 then
  begin
    MessageBoxA(Hdlg, 'File NOT Found!!', 'Error!', MB_OK);
    exit;
  end;
  for i := 1 to anzahl_patches do
  begin
    Seek(f,offsets[i]);
    Blockwrite(f,patchbytes[i],1);
  end;
  Closefile(f);
  MessageBoxA(Hdlg, 'Everything seemed to work fine!', ':-)', MB_OK);

end;

function MainProc(hdlg : HWND; Msg, wParam : WORD; lParam : longint): bool; stdcall;
begin
  case Msg of
  WM_INITDIALOG : begin
                    ReadPatchData(hdlg);
                    SetWindowText(hdlg,pchar('Patcher for '+ target_name));
                  end;  

  WM_CLOSE:
        begin
          PostQuitMessage(0);
        end;
  WM_COMMAND :
     case wParam of
       102: MessageBox(hdlg,'     This Patcher was generated by' + #10#13 +
                             'Sunshine' + #39 + 's Very Simple Patch Generator 1.0' + #10#13+
                             #10#13 +
                             'Visit my site : www.sunshine.2kx.de' + #10#13 +
                             'or mail me: Lloret01@gmx.de ' + #13#13 +
                             'Sunshine November 2001' + #13#13+
                             '-=Always dreaming of Lloret 2001=-',
                             'About...',mb_iconinformation);
       108 : PostQuitMessage(0);
       101 : PatchTarget(hdlg);
     end;
  
  end;
  MainProc := false;
end;


begin

    DialogBoxParam(hinstance,pchar('Mdlg'),0,@MainProc,0);
    ExitProcess(hinstance);

end.

