{-----------------------------------------------------------------------------
 Sunshine's Very Simple Patch Generator  1.0
 for more infos have a look at readme.txt
-----------------------------------------------------------------------------} 


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    Button1: TSpeedButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    Label8: TLabel;
    Image2: TImage;
    Label9: TLabel;
    Label10: TLabel;
    Timer1: TTimer;
    Button2: TSpeedButton;
    Shape1: TShape;
    Shape2: TShape;
    SpeedButton3: TSpeedButton;
    Button3: TSpeedButton;
    Shape3: TShape;
    Shape4: TShape;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label9Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  aboutstr = 'Sunshine'+#39+'s Very Simple Patch Generator    '+
             ' Version 1.0      24.11.01       Visit my site: '+
             'www.sunshine.2kx.de     or    mail me: Lloret01@gmx.de'+
             '         -=Always dreaming of Lloret 2001=-     ';

var
  Form1: TForm1;
  anzahl_patches : Integer;
  oribytes, patchbytes, offsets : array[1..1000] of Integer;
  filesize : longint;
  target_file : string;
  target_name : string;
  authorname : string;

  // for aboutstring
  count : Integer = 640;
 

implementation

{$R Patchexe.res}

//kleine Hilfsfunktion, mu dann nich immer so viel schreiben
//little function so I have not to write so much
procedure MyBox(text,cap : string);
begin
  MessageBox(form1.handle,pchar(text),pchar(cap),mb_iconinformation);
end;


//Schreibt einen String in eine Datei
//Writes a string to a file 
procedure Write_Str(file1 : TFileStream; was : string);
var
  i : Integer;
  temp : Integer;
begin
  i := 0;
  repeat
    i := i + 1;
    temp := ord(was[i]);

    file1.WriteBuffer(temp,1);
  until i = length(was);
end;  

{$R *.DFM}

// Vergleicht 2 Dateien und schreibt Unterschiede in Listview
// Compares 2 files and writes differences in listview
procedure TForm1.Button1Click(Sender: TObject);
var
  file1, file2 : TMemoryStream;
  i : Integer;
  Pbuf1, Pbuf2 : ^byte;
  buf1, buf2 : byte;
  NewEntry : TListItem;
begin
  // if there was already an comparison, delete it!
  for i := listview1.items.count-1 downto 0 do
    listview1.Items.delete(i);


  anzahl_patches := 0;
  if (edit1.text = '') or (edit2.text = '') then
  begin
    Mybox('Please choose 2 files!','Error');
    exit;
  end;

  file1 := TMemoryStream.Create;
  file2 := TMemoryStream.Create;
  file1.LoadFromFile(edit1.text);
  file2.LoadFromFile(edit2.text);
  if file1.Size <> file2.size then
  begin
    MyBox('Files must have the same size! Sorry!','Different file sizes');
    exit;
  end;
  label4.Caption := inttostr(file1.size)+ ' Bytes';
  filesize := file1.size;
  edit4.text := ExtractFileName(edit1.text);
  Pbuf1 := file1.Memory;
  Pbuf2 := file2.Memory;
  for i := 0 to file1.size do
  begin
    buf1 := Pbuf1^;
    buf2 := Pbuf2^;
    if buf1 <> buf2 then
    begin
      inc(Anzahl_patches);
      if anzahl_patches = 1000 then
      begin
        MyBox('Maximum of 1000 differences reached. Aborting...', 'Too many differences...');
        exit;
      end;  
      NewEntry := form1.listview1.items.add;
      NewEntry.caption := inttohex(i,8);
      NewEntry.subitems.add(inttohex(buf1,2));
      NewEntry.subitems.add(inttohex(buf2,2));


      oribytes[anzahl_patches] := buf1;
      patchbytes[anzahl_patches] := buf2;
      offsets[anzahl_patches] := i;
    end;
    inc(pbuf1);
    inc(pbuf2);
  end;
  file1.free;
  file2.free;
  
end;

// generiert den patch
// Generate patch
procedure TForm1.Button2Click(Sender: TObject);
var
  newfile : TFilestream;
  temp : Integer;
  i : Integer;
  Res : TResourceStream;
begin
  if (label4.caption = '') or (edit3.text = '')
  or (edit4.text = '') or (edit5.text = '') then
  begin
    MyBox('Please fill in all boxes!', 'Missing information');
    exit;
  end;


  IF SaveDialog1.Execute then
BEGIN

  // Daten einlesen
  // read infos
  target_file := edit4.text;
  authorname := edit3.text;
  target_name := edit5.text;


  // schreibt Patch aus Resource in Datei
  // Create Mainfile from Resource
  Res := TResourceStream.Create(hinstance,'Patchfile',pchar('EXEFILE'));
  try
   Res.SavetoFile(Savedialog1.Filename);
  finally
   Res.Free;
  end;



  // Ok nun Patch Daten dazuschreiben
  // now write info to end of patchfile
  newfile := TFilestream.Create(Savedialog1.Filename,fmopenreadwrite);
  newfile.Seek(newfile.size,sofrombeginning);

  // Target Filename + Length
  Write_Str(newfile,target_file);
  temp := length(target_file);
  newfile.WriteBuffer(temp,1);

  // Target Filesize  (always 4 Bytes long)
  newfile.WriteBuffer(filesize,4);

  // Authorname + Length
  Write_Str(newfile, authorname);
  temp := length(authorname);
  newfile.WriteBuffer(temp,1);

  // Target Name + Length
  Write_Str(newfile,target_name);
  temp := length(target_name);
  newfile.WriteBuffer(temp,1);

  // All Patchbytes, Original Bytes and Offsets
  for i := 1 to anzahl_patches do
  begin
    newfile.WriteBuffer(patchbytes[i],1);
    newfile.WriteBuffer(oribytes[i],1);
    newfile.WriteBuffer(offsets[i],3);
  end;
  // how many patches
  newfile.WriteBuffer(anzahl_patches,1);

  newfile.Free;
END;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  If Opendialog1.execute then
    edit1.text := opendialog1.FileName;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  If Opendialog2.execute then
    edit2.text := opendialog2.FileName;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  form1.close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  region: HRgn;
begin
  region:=CreateRoundRectRGN(5,24,645,400,20,20);
  SetWindowRgn(handle, region, true);
  form1.canvas.pen.color := clblack;
  form1.Canvas.brush.color := clblack;
end;

procedure TForm1.Label9Click(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TForm1.Label10Click(Sender: TObject);
begin
  form1.close;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  form1.Perform(WM_SYSCOMMAND,$f012,0);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  form1.Canvas.Font.color := clwhite;
  timer1.enabled := not timer1.enabled;
  form1.canvas.rectangle(0,350,image2.width,365);
end;

// writes aboutstr
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  form1.canvas.rectangle(0,350,image2.width,365);
  count := count - 2;
  form1.canvas.TextOut(count,350,aboutstr);
  if count < -850 then count := 640;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  form1.Perform(WM_SYSCOMMAND,$f012,0);
end;

procedure TForm1.Label8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  form1.Perform(WM_SYSCOMMAND,$f012,0);
end;

end.


{Eine andere Mglichkeit zum Dateienvergleich, nur vieeel langsamer
 Another possibility for comparing 2 files but very slow

var
  file1, file2 : TFileStream;
  i : Integer;
  buf1, buf2 : byte;
begin
  file1 := TFileStream.Create('D:\fenster.exe',fmopenread);
  file2 := TFileStream.Create('D:\fenster2.exe',fmopenread);

  for i := 0 to file1.size do
  begin
    File1.Seek(i,sofrombeginning);
    File2.Seek(i,sofrombeginning);
    file1.Read(buf1,1);
    file2.Read(buf2,1);
    if buf1 <> buf2 then
    begin
      listbox1.items.add('Offset: ' + inttohex(i,4));
    end;
  end;
  file1.free;
  file2.free;
end;}